MODULE Juego;

FROM IO IMPORT RdLn,WrCard,RdKey,WrStr,WrChar,WrLn,RdChar,KeyPressed,WrStr;

FROM Window IMPORT Clear,GotoXY,CursorOff;

FROM Lib IMPORT Speaker,Delay;

FROM Pantalla IMPORT Inicializa,ImprimeBorde,ActualizaPantalla,
								ImprimePantalla,Imagen,DestruirCoordenada,
									DestruirPantalla,Colision,Colision3;

FROM Jugador IMPORT CrearJugador,MoverDerecha,MoverIzquierda,
							Disparar,ImprimirJugador,DestruirJugador,
								TipoJugador,DesbloquearDisparo,EstaDisparando,
									Destruido;
								
FROM Serpient IMPORT TipoSerpiente,CrearNudo,ImprimirSerpiente,
								MoverSerpiente,DestruirSerpiente,UnirNudos,
									AcortarSerpiente,ColisionSerpiente,
										EstaDisparandoSerpiente,DispararSerpiente,
											CrearTiroSerpiente,DesbloquearSerpiente;
				

PROCEDURE Notas();
VAR
	tecla:CHAR;
BEGIN
	WrStr("JUAN JOSE LIBRERO VALLE 1B SISTEMAS ");WrLn;
	WrStr("Para moverse ");WrLn;
	WrStr("izq --------> 4 teclado numerico ");WrLn;
	WrStr("der --------> 6 teclado numerico ");WrLn;
	WrStr("disparo ----> Barra espaciadora  ");WrLn;
	WrStr("Pulse espacio para comenzar");
	REPEAT
		tecla:=RdKey();
	UNTIL tecla=CHR(32);
	Clear();
END Notas;
		
PROCEDURE Inicializacion(VAR pantalla:Imagen;VAR jug:TipoJugador;
									VAR x,y,dibujo,serpix,serpiy:CARDINAL;VAR fin:BOOLEAN;
										VAR serpi:TipoSerpiente);

(* ESTE PROCEDIMIENTO ME INICIALIZA TODA LA ESTRUCCTURA PRINCIPAL *)
VAR
	numero:CARDINAL;
	serpi1,serpi2,serpi3,serpi4,serpi5,serpi6,serpi7,serpi8:TipoSerpiente;
		
BEGIN
	Inicializa(pantalla);
	ImprimeBorde(pantalla);
	jug:=CrearJugador();
	x:=ImprimirJugador(jug);
	y:=23;
	dibujo:=0;
	ActualizaPantalla(pantalla,x,y,dibujo);
	fin:=FALSE;
	CrearNudo(serpi1,3);
	CrearNudo(serpi2,4);
	CrearNudo(serpi3,5);
	CrearNudo(serpi4,6);
	CrearNudo(serpi5,7);
	CrearNudo(serpi6,8);
	CrearNudo(serpi7,9);
	CrearNudo(serpi8,10);
	serpi:=UnirNudos(serpi1,serpi2,serpi3,serpi4,serpi5,serpi6,serpi7,serpi8);
	dibujo:=2;
	ImprimirSerpiente(pantalla,serpi);
	ImprimePantalla(pantalla);
END Inicializacion;


PROCEDURE Actualizacion(VAR pantalla:Imagen;VAR x,y,dibujo:CARDINAL);
(* REALIZA LA ACTUALIZACION DE LA PANTALLA *)
BEGIN	
	ImprimeBorde(pantalla);
	CursorOff;
	ActualizaPantalla(pantalla,x,y,dibujo);
	ImprimePantalla(pantalla);
END Actualizacion;	

PROCEDURE Destruccion(VAR pantalla:Imagen;VAR jug:TipoJugador;
								VAR serpi:TipoSerpiente);

(* LIBERA TODA LA MEMORIA DEL JUEGO *)
BEGIN
	DestruirPantalla(pantalla);
	DestruirJugador(jug);
	DestruirSerpiente(serpi);
END Destruccion;

PROCEDURE Acciones(VAR jug:TipoJugador;VAR serpi:TipoSerpiente;
							VAR pantalla:Imagen;VAR x,y,disparox,
								disparoy,serpix,serpiy,tiroserx,tirosery:CARDINAL):BOOLEAN;

(* ESTE ES EL PROCEDIMIENTO PRINCIPAL DEL JUEGO SE BASA EN LA REPETICION
	DE LAS ACCIONES DE LA SERPIENTE DISPARO ETC HASTA QUE EL JUGADOR MUEVE
	UNA TECLA LA CUAL DEPENDIENDO DE LA ACCION QUE REALICE MODIFICARA
	LOS PARAMETROS *)
(* PRIMERO CHEQUEA QUE NO HA SIDO DESTRUIDO PARA CONTINUAR CON LA ACCION
	DESPUES COMPRUEBA SI EL JUGADOR HA DISPARADO REALIZANDO LAS ACCIONES DEL
	DISPARO DEL JUGADOR SI NO ES ASI COMPRUEBA EL DISPARO DE LA SERPIENTE
	QUE SE ACTIVARA AUTOMATICAMENTE
	GRACIA A LA CONTINUA ACTUALIZACION SE BORRA EL PROYECTIL ANTERIOR *)

VAR
	dibujo,hijo:CARDINAL;
	final:BOOLEAN;	
	xtemp,ytemp:CARDINAL;
BEGIN
	final:=FALSE;
	REPEAT
		IF NOT Destruido(jug,serpix,serpiy,tiroserx,tirosery) THEN
			IF EstaDisparando(jug) THEN
				Speaker(500,50);
				dibujo:=1;
				DestruirCoordenada(pantalla,disparox,disparoy);
				disparoy:=disparoy-1;
				IF Colision(pantalla,disparox,disparoy) THEN
					DesbloquearDisparo(jug);
					DestruirCoordenada(pantalla,disparox,disparoy);
					Actualizacion(pantalla,disparox,disparoy,dibujo);
					IF ColisionSerpiente(serpi,disparox,disparoy) THEN
						Speaker(500,350);
						DestruirCoordenada(pantalla,tiroserx,tirosery);
						serpi:=AcortarSerpiente(pantalla,serpi,final);
					END;
						IF NOT final THEN
							dibujo:=3;
							DesbloquearDisparo(jug);
							DestruirCoordenada(pantalla,disparox,disparoy);
							Actualizacion(pantalla,disparox,disparoy,dibujo);
						ELSE
							WrStr("FIN de partida.Pulse algo");
						END;
				END;
				Actualizacion(pantalla,disparox,disparoy,dibujo);	
			END;		
			IF NOT(EstaDisparandoSerpiente(serpi)) THEN
				  DispararSerpiente(serpi);
				  CrearTiroSerpiente(serpi,tiroserx,tirosery);							
				  dibujo:=4;
			     DestruirCoordenada(pantalla,tiroserx,tirosery);
				  Actualizacion(pantalla,tiroserx,tirosery,dibujo);	
			ELSE
			 	dibujo:=4;
			 	IF Colision3(pantalla,tiroserx,tirosery+1) THEN
					DestruirCoordenada(pantalla,tiroserx,tirosery);
					Actualizacion(pantalla,tiroserx,tirosery,dibujo);
					DesbloquearSerpiente(serpi);
				END;			
				DestruirCoordenada(pantalla,tiroserx,tirosery);
				tirosery:=tirosery+1;
				Actualizacion(pantalla,tiroserx,tirosery,dibujo);
			 END;
			dibujo:=2;				   	
			IF NOT final THEN
				serpi:=MoverSerpiente(serpi,pantalla);
				ImprimirSerpiente(pantalla,serpi);
				Speaker(30,1);
				dibujo:=0;
				Actualizacion(pantalla,x,y,dibujo);
				Delay(75);
			END;
		ELSE
			dibujo:=5;
			xtemp:=ImprimirJugador(jug);
			ytemp:=23;
			Actualizacion(pantalla,xtemp,ytemp,dibujo);
			WrStr("Lo siento has sido destruido ");
			final:=TRUE;
		END;
	UNTIL KeyPressed();
	RETURN final;
END Acciones;

(********************* procedimiento principal *******************)
(* EL PROGRAMA BASICAMENTE CONSISTE EN
	INICIALIZACION
	ACCION
	DESTRUCCION  *)
	
(*	LA ACCION DEPENDERA DE LA TECLA PULSADA *)
VAR
	tecla:CHAR;
	fin:BOOLEAN;
	pantalla:Imagen;
	jug:TipoJugador;
	x,y,dibujo:CARDINAL;
	disparox,disparoy:CARDINAL;
	serpix,serpiy:CARDINAL;
	serpi:TipoSerpiente;
	tiroserx,tirosery:CARDINAL;

BEGIN
	Notas();
	Inicializacion(pantalla,jug,x,y,dibujo,serpix,serpiy,fin,serpi);	
   REPEAT
		fin:=Acciones(jug,serpi,pantalla,x,y,disparox,disparoy,serpix,serpiy,tiroserx,tirosery);
      tecla:=RdKey();
		CASE tecla OF
			|CHR(54): MoverDerecha(jug);
						 DestruirCoordenada(pantalla,x,y);
				       dibujo:=0;
				       x:=ImprimirJugador(jug);
				       y:=23;
				
			|CHR(52): MoverIzquierda(jug);
		             DestruirCoordenada(pantalla,x,y);
		             dibujo:=0;
		             x:=ImprimirJugador(jug);
		             y:=23;
		
			|CHR(32):  IF NOT(EstaDisparando(jug)) THEN
							  Disparar(jug);
			              disparox:=ImprimirJugador(jug);
			              disparoy:=22;
		   	           dibujo:=1;
		   	        END;
		   |CHR(27):
				fin:=TRUE;
			
			
		END
	UNTIL fin;
	Speaker(300,250);
   Speaker(200,200);
   Speaker(500,350);
   Speaker(150,200);
   Speaker(150,200);
	Destruccion(pantalla,jug,serpi);
END Juego.