IMPLEMENTATION MODULE Pantalla;


FROM IO IMPORT WrLn;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM Window IMPORT Clear,GotoXY;
FROM IO IMPORT WrChar;

CONST
	x=30;
	y=24;

TYPE
	Imagen=POINTER TO imagen;
	
	imagen=ARRAY[1..x],[1..y] OF CHAR;
	
PROCEDURE Inicializa(VAR pantalla:Imagen);
(*  ME INICIALIZA LA PANTALLA DE MODO QUE EN CADA POSICION EXISTA UN
	ESPACIO EN BLANCO *)
VAR
	i,j:CARDINAL;
BEGIN
	NEW(pantalla);
	FOR j:=1 TO y DO
		FOR i:=1 TO x DO
			pantalla^[i,j]:=CHR(32);
		END;
	END;
END Inicializa;

PROCEDURE HayPared(pantalla:Imagen;x,y:CARDINAL):BOOLEAN;
(* ME EXAMINA LA POSICION DADA Y ME DICE SI ENCUENTRA UNA PARED
	SE UTILIZARA EN EL MODULO SERPIENTE PARA CONSEGUIR LA PANTALLA
	REDONDA  *)
VAR
	col:BOOLEAN;
BEGIN
	IF pantalla^[x,y]=CHR(186) THEN
		col:=TRUE;
	ELSE
		col:=FALSE;
	END;
	RETURN col;
END HayPared;

PROCEDURE Colision(VAR pantalla:Imagen;x,y:CARDINAL):BOOLEAN;
(* ME INDICA QUE LA COORDENADA NO PERTENECE A UN ESPACIO EN BLANCO O A UNA
	PARED *)
VAR
	col:BOOLEAN;
BEGIN
	IF (pantalla^[x,y]=CHR(32)) OR (pantalla^[x,y]=CHR(186)) THEN
		col:=FALSE;
	ELSE
		col:=TRUE;
	END;
	RETURN col;
END Colision;

PROCEDURE Colision2(VAR pantalla:Imagen;x,y:CARDINAL):BOOLEAN;
(* ME INDICA SI EXISTE O NO UN ESPACIO EN BLANCO EN DICHA COORDENADA *)
VAR
	col:BOOLEAN;
BEGIN
	IF pantalla^[x,y]=CHR(32)  THEN
		col:=FALSE;
	ELSE
		col:=TRUE;
	END;
	RETURN col;
END Colision2;

PROCEDURE Colision3(VAR pantalla:Imagen;x,y:CARDINAL):BOOLEAN;
(* ME INDICA QUE LA COORDENADA NO PERTENECE AL SUELO *)
VAR
	col:BOOLEAN;
BEGIN
	IF pantalla^[x,y]=CHR(205)  THEN
		col:=TRUE;
	ELSE
		col:=FALSE;
	END;
	RETURN col;
END Colision3;

PROCEDURE ImprimeBorde(VAR pantalla:Imagen);
(* ESTE PROCEDIMIENTO IMPRIME EL BORDE EN MEMORIA NO EN LA PANTALLA *)
VAR
	i:CARDINAL;
BEGIN 	
	pantalla^[1,1]:=CHR(201);
	FOR i:=2 TO x-1 DO
		pantalla^[i,1]:=CHR(205);
	END;
	pantalla^[x,1]:=CHR(187);
	FOR i:=2 TO y-1 DO
		pantalla^[x,i]:=CHR(186);
	END;
	pantalla^[x,y]:=CHR(188);
   FOR i:=2 TO x-1 DO
		pantalla^[i,y]:=CHR(205);
	END;
	pantalla^[1,y]:=CHR(200);
	FOR i:=2 TO y-1 DO
		pantalla^[1,i]:=CHR(186);
	END;
END ImprimeBorde;

PROCEDURE ActualizaPantalla(VAR pantalla:Imagen;x,y,dibujo:CARDINAL);
(* DIBUJA EN LA COORDENADA DE MEMORIA UN DIBUJO
	QUEDARIA MEJOR CON TIPOS ENUMERADOS *)
(* NOTA; LA CODIFICACION DE DIBUJO ES LA SIGUIENTE
	0 --> NAVE
	1 --> TIRO
	2 --> ALIEN
	3 --> BLANCO
	4 --> BOMBA
	5 --> DESTRUIDO *)
BEGIN
	CASE dibujo OF
		|0: pantalla^[x,y]:=CHR(5);
		
		|1: pantalla^[x,y]:=CHR(9);
		
		|2: pantalla^[x,y]:=CHR(15);
		
		|3: pantalla^[x,y]:=CHR(32);
		
		|4: pantalla^[x,y]:=CHR(25);
		
		|5: pantalla^[x,y]:=CHR(190);
	END;
END ActualizaPantalla;

PROCEDURE ImprimePantalla(pantalla:Imagen);
(* AHORA SI SE DIBUJA LA ESTRUCCTURA EN LA PANTALLA *)
VAR
	i,j:CARDINAL;
BEGIN
	GotoXY(1,1);
	FOR j:=1 TO y DO
		FOR i:=1 TO x DO
			WrChar(pantalla^[i,j]);
		END;
		WrLn;
	END;

END ImprimePantalla;

PROCEDURE DestruirCoordenada(VAR pantalla:Imagen;x,y:CARDINAL);
(* BORRA DE MEMORIA LA COORDENADA DADA (CON UN ESPACIO EN BLANCO) *)
BEGIN
	pantalla^[x,y]:=CHR(32);
END DestruirCoordenada;

PROCEDURE DestruirPantalla(VAR pantalla:Imagen);
(* LIBERA LA MEMORIA DE LA PANTALLA *)
BEGIN
	DISPOSE(pantalla);

END DestruirPantalla;


END Pantalla.