IMPLEMENTATION MODULE Serpient;

FROM Storage IMPORT Available,ALLOCATE,DEALLOCATE;
FROM Pantalla IMPORT HayPared,Imagen,ActualizaPantalla,Colision,
								Colision2,DestruirCoordenada;
FROM Lib IMPORT Delay,RANDOMIZE,RANDOM;
FROM Window IMPORT Clear;
TYPE
	TipoSerpiente=POINTER TO Serpiente;
	
	Serpiente=RECORD
					x:CARDINAL;
					y:CARDINAL;
					dispara:BOOLEAN;
					sig:TipoSerpiente;
				END;
				
PROCEDURE CrearNudo(VAR serpi:TipoSerpiente;numero:CARDINAL);
(* CREA UNO DE LOS NUDOS DE LA SERPIENTE *)
VAR
	auxiliar:TipoSerpiente;
	creador:TipoSerpiente;
	i:CARDINAL;
BEGIN
	IF Available(SIZE(Serpiente)) THEN
		NEW(serpi);
		serpi^.x:=numero;
		serpi^.y:=3;
		serpi^.dispara:=FALSE;
		serpi^.sig:=NIL;
	END;
END CrearNudo;

PROCEDURE DesbloquearSerpiente(VAR serpi:TipoSerpiente);
 (* ESTE PROCEDIMIENTO DESBLOQUEA EL DISPARO DE LA SERPIENTE
 	EL PROCEDIMIENTO SIRVE TAMBIEN AL MODIFICAR EL PROGRAMA PARA QUE DISPAREN
 	LOS HIJOS ALEATORIAMENTE, EN ESTE CASO SOLO DISPARA EL PRIMERO *)
VAR
	auxiliar:TipoSerpiente;
BEGIN
	auxiliar:=serpi;
	WHILE auxiliar^.dispara=FALSE DO
		auxiliar:=auxiliar^.sig;
	END;
	auxiliar^.dispara:=FALSE;
END DesbloquearSerpiente;

PROCEDURE AcortarSerpiente(VAR pantalla:Imagen;serpi:TipoSerpiente;VAR final:BOOLEAN):TipoSerpiente;
(* LIBERA EL PRIMER HIJO DE LA SERPIENTE Y LO BORRA DE MEMORIA
   SI ES EL ULTIMO HIJO ENTONCES FINAL=TRUE Y SE ACAVA EL JUEGO *)
VAR
	auxiliar:TipoSerpiente;
BEGIN
	auxiliar:=serpi;
	serpi:=serpi^.sig;
	DestruirCoordenada(pantalla,auxiliar^.x,auxiliar^.y);
	DISPOSE(auxiliar);
	IF serpi#NIL THEN
		final:=FALSE;
	ELSE
		final:=TRUE;
	END;
	RETURN serpi;
END AcortarSerpiente;

PROCEDURE ColisionSerpiente(serpi:TipoSerpiente;x,y:CARDINAL):BOOLEAN;
(* INDICA SI LA SERPIENTE HA CHOCADO CON ALGO MIRANDO LA COORDENADA
	BUSCADA EN CADA UNO DE LOS HIJOS DE LA SERPIENTE *)
VAR
	encontrado:BOOLEAN;
	auxiliar:TipoSerpiente;
BEGIN
	encontrado:=FALSE;
	auxiliar:=serpi;
	WHILE ((auxiliar#NIL) AND (NOT encontrado)) DO
		IF ((auxiliar^.x=x) AND (auxiliar^.y=y)) THEN
			encontrado:=TRUE;
		END;
		auxiliar:=auxiliar^.sig;
	END;
	RETURN encontrado;	
END ColisionSerpiente;

PROCEDURE UnirNudos(serpi1,serpi2,serpi3,serpi4,serpi5,serpi6,
							serpi7,serpi8:TipoSerpiente):TipoSerpiente;

(* ESTE PROCEDIMIENTO UNE LOS 8 HIJOS PARA FORMAR LA SERPIENTE *)
VAR
	serpi:TipoSerpiente;
BEGIN
	serpi:=serpi1;
	serpi1^.sig:=serpi2;
	serpi2^.sig:=serpi3;
	serpi3^.sig:=serpi4;
	serpi4^.sig:=serpi5;
	serpi5^.sig:=serpi6;
	serpi6^.sig:=serpi7;
	serpi7^.sig:=serpi8;
	RETURN serpi;
END UnirNudos;	

PROCEDURE DestruirSerpiente(VAR serpi:TipoSerpiente);
(* LIBERA LA SERPIENTE DE LA MEMORIA *)
VAR
	auxiliar:TipoSerpiente;
BEGIN
	auxiliar:=serpi;
	WHILE auxiliar#NIL DO
		auxiliar:=serpi;
		serpi:=serpi^.sig;
		DISPOSE(auxiliar);
	END;
	serpi:=NIL;
END DestruirSerpiente;

PROCEDURE CrearTiroSerpiente(serpi:TipoSerpiente;VAR x,y:CARDINAL);
 (* DEVUELVE LA POSICION DE LA SERPIENTE QUE VA A DISPARAR.
 	ESTE PROCEDIMIENTO SERIVIRIA EN EL CASO DE QUE EL DISPARO DE
 	LA SERPIENTA FUERA POR UN HIJO ALEATORIO. EN ESTE CASO SOLO
 	DISPARA EL PRIMERO *)
VAR
	auxiliar:TipoSerpiente;
BEGIN
	auxiliar:=serpi;
	WHILE auxiliar^.dispara=FALSE DO
		auxiliar:=auxiliar^.sig;
	END;
	x:=auxiliar^.x;
	y:=auxiliar^.y;
END CrearTiroSerpiente;

PROCEDURE EstaDisparandoSerpiente(serpi:TipoSerpiente):BOOLEAN;
(* INDICA SI LA SERPIENTE HA EFECTUADO UN DISPARO *)
VAR
	auxiliar:TipoSerpiente;
	encontrado:BOOLEAN;
BEGIN
	auxiliar:=serpi;
	encontrado:=FALSE;
	WHILE ((auxiliar#NIL) AND (NOT encontrado)) DO
		IF auxiliar^.dispara=TRUE THEN
			encontrado:=TRUE;
		END;
		auxiliar:=auxiliar^.sig;
	END;
	RETURN encontrado;
END EstaDisparandoSerpiente;

PROCEDURE DispararSerpiente(VAR serpi:TipoSerpiente);
(* ACTIVA EL DISPARADOR DE LA SERPIENTE *)
BEGIN
	serpi^.dispara:=TRUE;

END DispararSerpiente;

PROCEDURE MoverSerpiente(VAR serpi:TipoSerpiente;pantalla:Imagen):TipoSerpiente;
(* MUEVE LA SERPIENTE
	EL PROCEDIMIENTO CONSISTE EN LO SIGUIENTE
	SE BORRA EL PRIMER HIJO
	SE CAMBIAN LAS COORDENADAS DE TODOS CON LA DEL HIJO POSTERIOR
		MENOS EL ULTIMO
	AL ULTIMO SE LE HACE UN ALEATORIO PARA QUE ELIJA UN CAMINO AL AZAR
	EL UNICO PROBLEMA ES QUE LA SERPIENTE PUEDE VOLVERSE Y EN LA PANTALLA
	DA LA IMPRESION DE QUE LA SERPIENTE ES MAS CORTA
	ESE ERROR NO LO HE PODIDO ARREGLAR AUNQUE ME CONVIENE PARA PODER
	DISPARAR DESDE UNA POSICION ALEATORIA *)
	
VAR
	anterior,posterior:TipoSerpiente;
	auxiliar,auxiliar2,auxiliar3:TipoSerpiente;
	movimiento,i:CARDINAL;
	error:BOOLEAN;
BEGIN
	anterior:=serpi;
	posterior:=serpi^.sig;
	WHILE posterior#NIL DO
		DestruirCoordenada(pantalla,anterior^.x,anterior^.y);
		anterior^.x:=posterior^.x;
		anterior^.y:=posterior^.y;
		posterior:=posterior^.sig;
		anterior:=anterior^.sig;
	END;
	error:=TRUE;
	auxiliar:=serpi;
	WHILE auxiliar^.sig#NIL DO
		auxiliar:=auxiliar^.sig;
	END;
	DestruirCoordenada(pantalla,auxiliar^.x,auxiliar^.y);
	REPEAT
		RANDOMIZE;
		movimiento:=RANDOM(8);
		CASE movimiento OF
			|0:   IF NOT(Colision(pantalla,auxiliar^.x,auxiliar^.y+1)) THEN
						auxiliar^.y:=auxiliar^.y+1;
					   error:=FALSE;
					END;
			
			|1:   IF NOT(Colision(pantalla,auxiliar^.x,auxiliar^.y-1)) THEN
						auxiliar^.y:=auxiliar^.y-1;
					   error:=FALSE;
					 END;
			
			|2:   IF NOT(Colision(pantalla,auxiliar^.x+1,auxiliar^.y)) THEN
						auxiliar^.x:=auxiliar^.x+1;
						IF HayPared(pantalla,auxiliar^.x,auxiliar^.y) THEN
							auxiliar^.x:=2;
						END;
						error:=FALSE;
					END;
			
			|3:   IF NOT(Colision(pantalla,auxiliar^.x-1,auxiliar^.y)) THEN
						auxiliar^.x:=auxiliar^.x-1;
						IF HayPared(pantalla,auxiliar^.x,auxiliar^.y) THEN
							auxiliar^.x:=29;
						END;
						error:=FALSE;
					END;
			
			|4:   IF NOT(Colision2(pantalla,auxiliar^.x+1,auxiliar^.y+1)) THEN
						auxiliar^.x:=auxiliar^.x+1;
						auxiliar^.y:=auxiliar^.y+1;
						error:=FALSE;
					END;
			
			|5:   IF NOT(Colision2(pantalla,auxiliar^.x-1,auxiliar^.y-1)) THEN
						auxiliar^.x:=auxiliar^.x-1;
						auxiliar^.y:=auxiliar^.y-1;
						error:=FALSE;
					END;
			
			|6:   IF NOT(Colision2(pantalla,auxiliar^.x+1,auxiliar^.y-1)) THEN
						auxiliar^.x:=auxiliar^.x+1;
						auxiliar^.y:=auxiliar^.y-1;
						error:=FALSE;
					END;
			
			|7:	IF NOT(Colision2(pantalla,auxiliar^.x-1,auxiliar^.y+1)) THEN
						auxiliar^.x:=auxiliar^.x-1;
						auxiliar^.y:=auxiliar^.y+1;
						error:=FALSE;
					END;
         END;
 	UNTIL NOT error;
 	RETURN serpi; 	 	 		
END MoverSerpiente;

PROCEDURE ImprimirSerpiente(VAR pantalla:Imagen;serpi:TipoSerpiente);
(* GUARDA LA SERPIENTE EN LA MEMORIA *)
VAR
	auxiliar:TipoSerpiente;
	i,x,y,dib:CARDINAL;
BEGIN
	dib:=2;
	auxiliar:=serpi;
	WHILE auxiliar#NIL DO
		x:=auxiliar^.x;
		y:=auxiliar^.y;
		ActualizaPantalla(pantalla,x,y,dib);	
		auxiliar:=auxiliar^.sig;
	END;
	
END ImprimirSerpiente;

END Serpient.